// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "LoaderForSceneItems.hpp"
#include "scene/Scene.hpp"

namespace Dawn {
  
  enum class PrefabLoaderState {
    INITIAL,
    LOADING_JSON,
    LOADING_DEPENDENCIES,
    DEPENDENCIES_LOADED,
    DONE
  };

  class PrefabLoader : public LoaderForSceneItems {
    protected:
      PrefabLoaderState state = PrefabLoaderState::INITIAL;
      std::shared_ptr<SceneItem> item;

    public:
      const static std::string ASSET_TYPE;

      PrefabLoader(
        const std::shared_ptr<AssetManager> assetManager,
        const std::string name
      );
      
      void updateSync() override;
      void updateAsync() override;
      std::string getAssetType() const override;

      ~PrefabLoader();
  };
}